import javax.microedition.lcdui.*;
import javax.microedition.rms.*;
import java.util.Random;

final class TakeCrossCanvas extends Canvas
    implements Runnable,CommandListener {


    private final int BACKCOLOR = (57<<16) + (221<<8) + 156;
    // (XMAX * YMAX) must less than 127!
    private final int XMAX = 6;
    private final int YMAX = 5;
    //private final int CELLSIZE=22;
    //final String CATALOGNAME=new String("hqVk.DATA");
    private Cell[][] Cells = new Cell[XMAX][YMAX];
    private int CurX; // cursor X
    private int CurY; // corsor Y
    private int BColor; // ubN̐F

    private int Qlevel = 0;
    private int Left = 0;
    private int Nokori = 0;
    private Random rand = new Random();
    private int HighScore = 0;

    private final static int
        S_NEXTGAME = 0, // ̃Q[쐬
        S_TITLE   =1, //^Cg
        S_PLAY    =2, //vC
        S_GAMEOVER=3; //Q[I[o[
    
    //VXe
    private Image[] image = new Image[6]; // cell C[W
    private int init = -1;          // ̃V[
    private int scene = S_NEXTGAME;     // V[
    private String  msg;               // bZ[W

    int BaseX, BaseY; // W_
    
    // J[\
    private int curX; // X W
    private int curY; // Y W
    
    //_uobt@O
    private Image imgOff;//ItC[W
    private Graphics graOff;//ItOtBNX
    
    
    // Constructor
    public TakeCrossCanvas() {
        // ItC[W̐
        imgOff=Image.createImage(getWidth(),getHeight());
        graOff=imgOff.getGraphics();
        
        // X^[g{^̐
        addCommand(new Command("START",Command.SCREEN,0));
        setCommandListener(this);
        
        try {
            //C[W̓ǂݍ
            for (int i = 5; i >= 0; i--) {
                image[i] =Image.createImage("/"+i+".png"); // 0 = void
            }
        } catch (Exception e) {
        }

        // initialize Cells
	for(int x = 0; x < XMAX; x++){
	    for(int y = 0; y < YMAX; y++){
		Cells[x][y]=new Cell();
	    }
	}
	Qlevel=1;
        BaseX = (getWidth() - 17 * XMAX) / 2;
        BaseY = (getHeight() - 17 * YMAX) / 2;
        
        init = S_TITLE;
        loadHighScore();
    }

    public void saveHighScore() {
        try {
            RecordStore rs = RecordStore.openRecordStore("TakeCross", true);
            byte[] b = Integer.toString(HighScore).getBytes();
            if(rs.getNumRecords() == 0) {
                rs.addRecord(b, 0, b.length);
            }
            else {
                rs.setRecord(1, b, 0, b.length);
            }
            rs.closeRecordStore();
        } catch(Exception e) {
        }
    }
    public void loadHighScore() {
        try {
            RecordStore rs = RecordStore.openRecordStore("TakeCross", false);
            HighScore = Integer.parseInt(new String(rs.getRecord(1)));
            rs.closeRecordStore();
        } catch(Exception e) {
        }
    }

    public void oneReverse(int x, int y) {
	if(x >= 0 && x < XMAX && y >= 0 && y < YMAX){
	    Cells[x][y].reverse();
	    if(Cells[x][y].dot == true){
		Left++;
	    }
	    else{
		Left--;
	    }
            if(Cells[x][y].dot == true) {
                graOff.drawImage(image[BColor]
                                 , BaseX + 17 * x
                                 , BaseY + 17 * y
                                 , Graphics.LEFT|Graphics.TOP);
            }
            else {
                graOff.drawImage(image[0]
                                 , BaseX + 17 * x
                                 , BaseY + 17 * y
                                 , Graphics.LEFT|Graphics.TOP);
            }
	}
	else{
	    return;
	}

    }

    public void nextGame(){
	//Sound.beep();
	Left = 0;
	for(int x = 0; x < XMAX; x++){
	    for(int y = 0; y < YMAX; y++){
                Cells[x][y].dot = false;
            }
        }
	while(Left == 0){
	    // make pattern
	    for(int i = 0; i < Qlevel; i++){
                int x = (rand.nextInt() >>> 1) % XMAX;
                int y = (rand.nextInt() >>> 1) % YMAX;
                starReverse(x, y);
	    }
	}
        Nokori = Qlevel * 2;
        BColor = (Qlevel % 4) + 1;
        // wi
        graOff.setColor(BACKCOLOR);
        graOff.fillRect(0,0,getWidth(),getHeight());
        // ubN
	for(int x = 0; x < XMAX; x++){
	    for(int y = 0; y < YMAX; y++){
                if(Cells[x][y].dot == true) {
                    graOff.drawImage(image[BColor]
                                     , BaseX + 17 * x
                                     , BaseY + 17 * y
                                     , Graphics.LEFT|Graphics.TOP);
                }
                else {
                    graOff.drawImage(image[0]
                                     , BaseX + 17 * x
                                     , BaseY + 17 * y
                                     , Graphics.LEFT|Graphics.TOP);
                }
            }
        }
        if(Qlevel - 1 > HighScore) {
            HighScore = Qlevel - 1;
            saveHighScore();
        }
        graOff.setColor((255<<16) + (255<<8) + 255);
        graOff.drawString("HighScore: " + String.valueOf(HighScore)
                          , 5
                          , getHeight() - 2
                          , Graphics.LEFT|Graphics.BOTTOM);
        showCursor();
        repaint();
    }


    public void starReverse(int x, int y) {
        /*
	Sound.beep();
        */
	oneReverse(x, y);
	oneReverse(x - 1, y);
        oneReverse(x + 1, y);
	oneReverse(x, y - 1);
	oneReverse(x, y + 1);
    }        

    // C[v
    public void run() {
        while (true) {
            repaint();
            try {
                Thread.sleep(10);
            } catch (Exception e) {
            }
        }
    }

    //`
    public synchronized void paint(Graphics g) {
        // 
        if (init >= 0) {
            scene = init;
            init = -1;
            msg = null;
            // ^Cg
            if (scene == S_TITLE) {
                msg = "TAKE Cross!";
            }
            // Q[I[o[
            if (scene==S_GAMEOVER) {
                msg = "GAME OVER";
            }
        }

        // 
        if(scene == S_NEXTGAME){
            scene = S_PLAY;
            nextGame();
        }
        
        // `
        /*
        // wi
        graOff.setColor(BACKCOLOR);
        graOff.fillRect(0,0,getWidth(),getHeight());
        */
        /*
        // J[\
        if(scene == S_PLAY) {
            graOff.setColor(255, 255, 0);
            graOff.fillRect(BaseX + 17 * CurX - 2
                            , BaseY + 17 * CurY - 2
                            , 19, 19);
        }
        */
        /*
        // ubN
	for(int x = 0; x < XMAX; x++){
	    for(int y = 0; y < YMAX; y++){
                if(Cells[x][y].dot == true) {
                    graOff.drawImage(image[BColor]
                                     , BaseX + 17 * x
                                     , BaseY + 17 * y
                                     , g.LEFT|g.TOP);
                }
                else {
                    graOff.drawImage(image[0]
                                     , BaseX + 17 * x
                                     , BaseY + 17 * y
                                     , g.LEFT|g.TOP);
                }
            }
        }
        */
        //XRA
        graOff.setColor(BACKCOLOR);
        graOff.fillRect(0, 0, getWidth(), BaseY - 2);

        graOff.setColor((255<<16) + (255<<8) + 255);
        graOff.drawString("Level: " + String.valueOf(Qlevel)
                          + "  Left: " + String.valueOf(Nokori)
                          , 5
                          , 2
                          , g.LEFT|g.TOP);

        /*
        // vC̏
        if(scene == S_PLAY) {
        }
        */
        //^CgEQ[I[o[̏
        if(scene != S_PLAY) {
            if(scene == S_TITLE) {
                // wi
                graOff.setColor((255<<16)+(80<<8)+80);
                graOff.fillRect(0, 0, getWidth(), getHeight());
            }
            // bZ[W
            graOff.setColor((255<<16)+(150<<8)+150);
            for(int i = -3; i <= 3; i++) {
                for(int j = -3; j <= 3; j++) {
                    graOff.drawString(msg
                                      ,getWidth() / 2 + i
                                      ,getHeight() / 2 + j
                                      ,g.HCENTER|g.TOP);
                }
            }
            graOff.setColor(255<<16);
            graOff.drawString(msg
                              ,getWidth() / 2
                              ,getHeight() / 2
                              ,g.HCENTER|g.TOP);
        }
        
        // ItC[W̕\
        g.drawImage(imgOff,0,0,g.LEFT|g.TOP);
    }
    
    // key press events
    protected synchronized void keyPressed(int keyCode) {
        if(scene != S_PLAY) {
            return;
        }
        // game actions
        int action = getGameAction(keyCode);
        clearCursor();
        if(action == UP) {
            CurY--;
            if(CurY < 0) {
                CurY = YMAX - 1;
            }
        }
        else if (action == DOWN) {
            CurY++;
            if(CurY >= YMAX) {
                CurY = 0;
            }
        }
        else if(action == LEFT) {
            CurX--;
            if(CurX < 0) {
                CurX = XMAX - 1;
            }
        }
        else if(action == RIGHT) {
            CurX++;
            if(CurX >= XMAX) {
                CurX = 0;
            }
        }
        else if(action == FIRE) {
            starReverse(CurX, CurY);
            Nokori--;
            if(Left == 0) {
                Qlevel++;
                init = S_NEXTGAME;
            }
            else if(Nokori == 0) {
                init = S_GAMEOVER;
            }
        }
        showCursor();
        repaint();
    }

    public void showCell(int x, int y) {
        if(Cells[x][y].dot == true) {
            graOff.drawImage(image[BColor]
                             , BaseX + 17 * x
                             , BaseY + 17 * y
                             , Graphics.LEFT|Graphics.TOP);
        }
        else {
            graOff.drawImage(image[0]
                             , BaseX + 17 * x
                             , BaseY + 17 * y
                             , Graphics.LEFT|Graphics.TOP);
        }
    }
    public void clearCursor() {
        if(scene == S_PLAY) {
            graOff.setColor(BACKCOLOR);
            graOff.fillRect(BaseX + 17 * CurX - 2
                            , BaseY + 17 * CurY - 2
                            , 19, 19);
            showCell(CurX, CurY);
            /*
            graOff.fillRect(BaseX + 17 * CurX - 2
                            , BaseY + 17 * CurY - 2
                            , 19, 2);
            graOff.fillRect(BaseX + 17 * CurX - 2
                            , BaseY + 17 * CurY - 2
                            , 2, 19);
            graOff.fillRect(BaseX + 17 * CurX + 15
                            , BaseY + 17 * CurY - 2
                            , 2, 19);
            graOff.fillRect(BaseX + 17 * CurX - 2
                            , BaseY + 17 * CurY +15
                            , 19, 2);
            */
        }
    }
    public void showCursor() {
        if(scene == S_PLAY) {
            graOff.setColor((255<<16) + (255<<8));
            graOff.fillRect(BaseX + 17 * CurX - 2
                            , BaseY + 17 * CurY - 2
                            , 19, 19);
            showCell(CurX, CurY);
            /*
            graOff.fillRect(BaseX + 17 * CurX - 2
                            , BaseY + 17 * CurY - 2
                            , 19, 2);
            graOff.fillRect(BaseX + 17 * CurX - 2
                            , BaseY + 17 * CurY - 2
                            , 2, 19);
            graOff.fillRect(BaseX + 17 * CurX + 15
                            , BaseY + 17 * CurY - 2
                            , 2, 19);
            graOff.fillRect(BaseX + 17 * CurX - 2
                            , BaseY + 17 * CurY +15
                            , 19, 2);
            */
        }
    }

    //R}hCxg
    public synchronized void commandAction(Command c, Displayable s) {
        if(init < 0) {
            if(scene == S_TITLE){
                Qlevel = 1;
                init = S_NEXTGAME;
            }
            if(scene==S_GAMEOVER){
                init = S_TITLE;
            }
        }
    }
}
